-- get the addon namespace
local addon, ns = ...
 
-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if not lib.isDK() then return end

local TalentsFrame=CreateFrame('Frame')
TalentsFrame:Show()
--[[local gcd=CreateFrame("Frame")
gcd.name=GetSpellInfo(47541)
gcd.cd=0
gcd.start=0]]

local function handler(msg, editbox)
	local cmd, rest = msg:match("^(%S*)%s*(.-)$");
	if (cmd~="") then
		local num = rest
		if (cmd=="x") then
			if num~=nil and num~="" then
				cfg.x=num
			end
			print("x = "..x);
		elseif (cmd=="y") then
			if num~=nil and num~="" then
				cfg.y=num
			end
			print("y = "..y);
		elseif (cmd=="hrp") then
			if num~=nil and num~="" then
				cfg.hrp=num
			end
			print("hrp = "..hrp);
		elseif (cmd=="hdes") then
			if num~=nil and num~="" then
				cfg.hdes=num
			end
			print("hdes = "..hdes);
		elseif (cmd=="size") then
			if num~=nil and num~="" then
				cfg.rsize=num
			end
			print("size = "..rsize);
		elseif (cmd=="space") then
			if num~=nil and num~="" then
				cfg.rspace=num
			end
			print("space = "..rspace);
--[[		elseif (cmd=="freq") then
			if num~=nil and num~="" then
				freq=num
			end
			print("freq = "..freq);]]
		end
		moveframes()
	else
  print("Syntax: /hrune [x y hrp hdes size space] number");
 end
end

local RUNETYPE_BLOOD = 1;
local RUNETYPE_UNHOLY = 2;
local RUNETYPE_FROST = 3;
local RUNETYPE_DEATH = 4;

--[[local iconTextures = {};
iconTextures[RUNETYPE_BLOOD] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood";
iconTextures[RUNETYPE_UNHOLY] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy";
iconTextures[RUNETYPE_FROST] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost";
iconTextures[RUNETYPE_DEATH] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Death";

local runeTextures = {
	[RUNETYPE_BLOOD] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Blood-Off.tga",
	[RUNETYPE_UNHOLY] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Death-Off.tga",
	[RUNETYPE_FROST] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Frost-Off.tga",
	[RUNETYPE_DEATH] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Chromatic-Off.tga",
}

local runeColors = {
	[1] = {1, 0, 0},
	[2] = {0, 0.5, 0},
	[3] = {0, 1, 1},
	[4] = {0.8, 0.1, 1},
}]]
local runeColors = {
	[RUNETYPE_BLOOD] = {1, 0, 0},
	[RUNETYPE_UNHOLY] = {0, 0.5, 0},
	[RUNETYPE_FROST] = {0, 1, 1},
	[RUNETYPE_DEATH] = {0.8, 0.1, 1},
}
local runeMapping = {
	[1] = "BLOOD",
	[2] = "UNHOLY",
	[3] = "FROST",
	[4] = "DEATH",
}


function moveframes()
	HruneFrame:SetHeight(cfg.rsize*2)
	HruneFrame:SetWidth(cfg.rsize*3+cfg.rspace*2)
	HruneFrame:SetPoint("CENTER", UIParent, "CENTER", cfg.x, cfg.y)
	Hrp:SetHeight(cfg.hrp)
	Hrp:SetWidth(cfg.rsize*3+cfg.rspace*2)
	Hd:SetHeight(cfg.hdes*2)
	Hd:SetWidth(cfg.rsize*3+cfg.rspace*2)
	for i=1, 2 do
		Hd[i]:SetPoint("TOP",Hd,"TOP",0,-cfg.hdes*(i-1))
		Hd[i]:SetHeight(cfg.hdes)
		Hd[i]:SetWidth(cfg.rsize*3+cfg.rspace*2)
	end
	for i = 1, 6 do
		HruneFrame[i]:SetHeight(cfg.rsize)
		HruneFrame[i]:SetWidth(cfg.rsize)
		HruneFrame[i].bg:SetAllPoints(HruneFrame[i])
		HruneFrame[i].shine:SetHeight(cfg.rsize*3);
		HruneFrame[i].shine:SetWidth(cfg.rsize*3);
	end
	HruneFrame[1]:SetPoint("TOPLEFT", HruneFrame, "TOPLEFT", 0, 0);
	HruneFrame[2]:SetPoint("BOTTOMLEFT", HruneFrame, "BOTTOMLEFT", 0, 0);
	HruneFrame[3]:SetPoint("LEFT", HruneFrame[1], "RIGHT", cfg.rspace, 0);
	HruneFrame[4]:SetPoint("LEFT", HruneFrame[2], "RIGHT", cfg.rspace, 0);
	HruneFrame[5]:SetPoint("LEFT", HruneFrame[3], "RIGHT", cfg.rspace, 0);
	HruneFrame[6]:SetPoint("LEFT", HruneFrame[4], "RIGHT", cfg.rspace, 0);
end

-- Create frame
function Hrune_Create()
	HruneFrame = _G["HruneFrame"] or CreateFrame('Frame',"HruneFrame",UIParent)
	HruneFrame:SetHeight(cfg.rsize*2)
	HruneFrame:SetWidth(cfg.rsize*3+cfg.rspace*2)
	HruneFrame:SetPoint("CENTER", UIParent, "CENTER", cfg.x, cfg.y)
--[[	HruneFrame.texture = HruneFrame:CreateTexture(nil,"BACKGROUND")
	HruneFrame.texture:SetAllPoints(HruneFrame)
	HruneFrame.texture:SetTexture(135/255,206/255,235/255,0.5 )
	HruneFrame:Show()]]
--	print(cfg.statusbar_texture)
	HruneFrame.lu=0
	Hrp = _G["Hrp"] or CreateFrame('StatusBar', "Hrp",HruneFrame)
	Hrp:SetStatusBarTexture(cfg.statusbar_texture)
	Hrp:SetMinMaxValues(0,lib.rp())
	Hrp:SetPoint("BOTTOM",HruneFrame,"TOP")
	Hrp:SetHeight(cfg.hrp)
	Hrp:SetWidth(cfg.rsize*3+cfg.rspace*2)
	Hrp:SetValue(0)
	Hrp.text=Hrp:CreateFontString("Hrp_text","OVERLAY")
	Hrp.text:SetFont(cfg.textfont, cfg.textsize-2, "OUTLINE")
	Hrp.text:SetPoint("RIGHT",Hrp,"LEFT");
	Hrp.lu=0
	Hrp.freq=cfg.freq

	Hd = _G["Hd"] or CreateFrame('Frame',"Hd",HruneFrame)
	Hd:SetHeight(cfg.hdes*2)
	Hd:SetWidth(cfg.rsize*3+cfg.rspace*2)
	Hd:SetPoint("TOP",HruneFrame,"BOTTOM")
	Hd.lu=0

	for i=1, 2 do
		Hd[i] = _G["Hd"..i] or CreateFrame('StatusBar', "Hd"..i,Hd)
		Hd[i]:SetStatusBarTexture(cfg.statusbar_texture)
		Hd[i]:SetMinMaxValues(0,lib.dt())
		Hd[i]:SetPoint("TOP",Hd,"TOP",0,-cfg.hdes*(i-1))
		Hd[i]:SetHeight(cfg.hdes)
		Hd[i]:SetWidth(cfg.rsize*3+cfg.rspace*2)
		Hd[i]:SetValue(0)
		Hd[i].text=Hrp:CreateFontString("Hd_text"..i,"OVERLAY")
		Hd[i].text:SetFont(cfg.textfont, cfg.textsize-3, "OUTLINE")
		Hd[i].text:SetPoint("RIGHT",Hd[i],"LEFT");
	end

	Hd[1]:SetStatusBarColor(0,1,0);
	Hd[2]:SetStatusBarColor(0,1,1);

	for i = 1, 6 do
		HruneFrame[i] = _G["Hrune"..i] or CreateFrame('StatusBar', "Hrune"..i, HruneFrame)
		HruneFrame[i]:SetStatusBarTexture(cfg.statusbar_texture)
		HruneFrame[i]:SetHeight(cfg.rsize);
		HruneFrame[i]:SetWidth(cfg.rsize);
		HruneFrame[i].bg = HruneFrame[i]:CreateTexture(nil, 'BACKGROUND')
		HruneFrame[i].bg:SetTexture(cfg.statusbar_texture)
		HruneFrame[i].bg:SetAllPoints(HruneFrame[i])
		HruneFrame[i].bg:SetAlpha(0.3)
		HruneFrame[i].text=HruneFrame[i]:CreateFontString('Hrune'..i..'text', "OVERLAY")
		HruneFrame[i].text:SetAllPoints(HruneFrame[i])
		HruneFrame[i].text:SetFont(cfg.textfont, cfg.textsize, "OUTLINE")
		HruneFrame[i].text:SetTextColor(1,1,0);
		HruneFrame[i].lu=0
		HruneFrame[i].freq=1
		HruneFrame[i]:SetID(i);
		HruneFrame[i].tooltipText=nil
		HruneFrame[i]:SetMinMaxValues(0,10)
		HruneFrame[i]:SetValue(10)
		HruneFrame[i]:EnableMouse(true)
		HruneFrame[i]:SetScript("OnEnter", HruneButton_OnEnter)
		HruneFrame[i]:SetScript("OnLeave", HruneButton_OnLeave)
		HruneFrame[i]:SetScript("OnUpdate", Hrune_Update);
		HruneFrame[i].shine = HruneFrame[i]:CreateTexture(nil,"OVERLAY")
		HruneFrame[i].shine:SetHeight(cfg.rsize*3);
		HruneFrame[i].shine:SetWidth(cfg.rsize*3);
		--	HruneFrame[i].shine:SetAllPoints(HruneFrame[i])
		HruneFrame[i].shine:SetPoint("CENTER",HruneFrame[i],"CENTER")
		HruneFrame[i].shine:SetTexture("Interface\\ComboFrame\\ComboPoint")
		HruneFrame[i].shine:SetTexCoord(0.5625,1,0,1) -- 0.5625,1,0,1
		HruneFrame[i].shine:SetAlpha(0)
	end

	HruneFrame[1]:SetPoint("TOPLEFT", HruneFrame, "TOPLEFT", 0, 0);
	HruneFrame[2]:SetPoint("BOTTOMLEFT", HruneFrame, "BOTTOMLEFT", 0, 0);
	HruneFrame[3]:SetPoint("LEFT", HruneFrame[1], "RIGHT", cfg.rspace, 0);
	HruneFrame[4]:SetPoint("LEFT", HruneFrame[2], "RIGHT", cfg.rspace, 0);
	HruneFrame[5]:SetPoint("LEFT", HruneFrame[3], "RIGHT", cfg.rspace, 0);
	HruneFrame[6]:SetPoint("LEFT", HruneFrame[4], "RIGHT", cfg.rspace, 0);
end

function Hrune_Update (self) -- elapsed
	local now = GetTime()
	if (now >= self.lu + self.freq) then
		self.lu=now
		local rune=self:GetID()
		local runeType = GetRuneType(rune);
		if (runeType) then
			self:SetStatusBarColor(unpack(runeColors[runeType]))
			self.bg:SetVertexColor(unpack(runeColors[runeType]))
			self:Show();
			self.tooltipText = _G["COMBAT_TEXT_RUNE_"..runeMapping[runeType]];
		else
			self:Hide();
			self.tooltipText = nil;
		end

		local start, duration, runeReady = GetRuneCooldown(rune)
		if (runeReady or (now - start) >= duration) then
			if self.freq==0 then
				UIFrameFadeIn(self.shine,0.3,0,1)
				self.shine.fadeInfo.finishedFunc = function()
					UIFrameFadeOut(self.shine,0.3,1,0)
				end
			end
			self.freq=1
			if not (self:GetValue()==10) then self:SetValue(10) end
		else
			self.freq=cfg.freq
			--[[local cur = floor(now + 0.5)
			start = floor(start+0.5)]]
			local cur = now
			if not (self:GetValue()==(cur-start)) then self:SetValue(cur-start) end
		end
		
		-- Cooldown
		local rcd=floor(duration-(now - start) + 0.5)
		if rcd==0 then rcd="" end
		local rgreen=1
		if (runeReady or (now - start) >= duration) then
			rcd=""
		elseif (duration-(now - start) < 3) then
			_,rgreen,_ = self.text:GetTextColor()
			if (rgreen > 0) then 
				rgreen=0
			else
				rgreen=1
			end
		end
		self.text:SetTextColor(1,rgreen,0)
		self.text:SetText(rcd)
	end
end

function HruneButton_OnEnter(self)
	if ( self.tooltipText ) then
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetText(self.tooltipText)
		GameTooltip:Show()
	end
end

function HruneButton_OnLeave(self)
	GameTooltip:Hide()
end

local function LoadTalents()
	for i=1, 2 do
		Hd[i]:SetMinMaxValues(0,lib.dt())
	end
	Hrp:SetMinMaxValues(0,lib.rp())
	TalentsFrame:Hide()
end

function HruneFrame_OnLoad (self)
	lib.hideRuneFrame()
		
	Hrune_Create()
	
	HruneFrame:RegisterEvent("RUNE_POWER_UPDATE");
	HruneFrame:RegisterEvent("RUNE_TYPE_UPDATE");
	HruneFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
	HruneFrame:RegisterEvent("PLAYER_UNGHOST");
	HruneFrame:SetScript("OnEvent", HruneFrame_OnEvent);
	HruneFrame:SetScript("OnUpdate", HruneFrame_Update);
	Hrp:RegisterEvent("UNIT_RUNIC_POWER");
	Hrp:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	Hrp:RegisterEvent("CHARACTER_POINTS_CHANGED");
	Hrp:RegisterEvent("PLAYER_ENTERING_WORLD")
	Hrp:RegisterEvent("PLAYER_ALIVE")
	Hrp:SetScript("OnEvent", Hrp_OnEvent);
	Hrp:SetScript("OnUpdate", Hrp_Update);
	
	
	Hd:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
	Hd:RegisterEvent("UNIT_AURA");
	Hd:RegisterEvent("PLAYER_TARGET_CHANGED");
	Hd:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	Hd:RegisterEvent("CHARACTER_POINTS_CHANGED");
	Hd:RegisterEvent("PLAYER_ENTERING_WORLD")
	Hd:RegisterEvent("PLAYER_ALIVE")
	Hd:SetScript("OnEvent", Hd_OnEvent);
	TalentsFrame:SetScript("OnUpdate", LoadTalents)
--[[	SLASH_HRUNE1 = '/hrune'
	SlashCmdList["HRUNE"] = handler;]]
end

function rangecheck(self)
--	if (UnitExists("target") and not UnitIsDead("target")) then
--	print(IsSpellInRange(GetSpellInfo(45462),"target"))
	local rng=IsSpellInRange(GetSpellInfo(45462),"target")
		if (not rng) or rng==1 then
			for i=1,6 do
				self[i]:GetStatusBarTexture():SetDesaturated(nil)
			end
		else
			for i=1,6 do
				self[i]:GetStatusBarTexture():SetDesaturated(1)
			end
		end
--	else
--[[		for i=1,6 do
			self[i]:GetStatusBarTexture():SetDesaturated(nil)
		end]]
--	end
end

function HruneFrame_Update(self,elapsed)
	local now = GetTime()
	if (now >= self.lu + cfg.freq) then
		rangecheck(self)
	end
end

function Hd_Update(self,des,dt,num)
	if (not (self[des]:GetValue()==dt)) then
		self[des]:SetValue(dt)
		if (num>1) then
			self[des]:SetStatusBarColor(1,0,0);
		else
			if des==1 then
				self[des]:SetStatusBarColor(0,1,0);
			else
				self[des]:SetStatusBarColor(0,1,1);
			end
		end
	end
	
	if dt>0 then
		local hred=1
		if dt<3 then
			_,hred,_ = self[des].text:GetTextColor()
			if (hred > 0) then 
				hred=0
			else
				hred=1
			end
		end
		self[des].text:SetTextColor(1,hred,hred)
		self[des].text:SetText(floor(dt))
		self:SetScript("OnUpdate", Hd_check);
	else
		self[des].text:SetText("")
		self:SetScript("OnUpdate", nil);
	end
end

function Hd_check(self)
	local now = GetTime()
	if (now >= self.lu + cfg.freq) then
		self.lu=now
		local dc={}
		dc[1]=0
		dc[2]=0
	
		for i=1,40 do 
			local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable = UnitDebuff("target", i) 
			local isMine = cfg.my_units[caster]
			if (isMine) then
				if name==GetSpellInfo(55095) then
					dc[2]=dc[2]+1
					Hd_Update(self,2,(expirationTime-GetTime()),dc[2])
				elseif name==GetSpellInfo(55078) then
					dc[1]=dc[1]+1
					Hd_Update(self,1,(expirationTime-GetTime()),dc[1])
				end
			end
		end
		for i=1,2 do
			if dc[i]==0 then
				Hd_Update(self,i,0,1)
			end
		end
	end
end

function Hd_OnEvent (self, event, unit)
	if event=="ACTIONBAR_UPDATE_COOLDOWN" or "PLAYER_TARGET_CHANGED" or (event=="UNIT_AURA" and unit=="target") then
--[[		if event=="ACTIONBAR_UPDATE_COOLDOWN" then
			local s, d, en = GetSpellCooldown(gcd.name)
			if (s>0 and d>0 and en) then
				gcd.cd=d
				gcd.start=s
				print(gcd.cd)
			else
				gcd.cd=0
				gcd.start=0
			end
		end]]
		Hd_check(self)
	end
	if event=="CHARACTER_POINTS_CHANGED" or event=="ACTIVE_TALENT_GROUP_CHANGED" or event=="PLAYER_ENTERING_WORLD" or event=="PLAYER_ALIVE" then
		for i=1, 2 do
--			print(i)
--			print(lib.dt())
			self[i]:SetMinMaxValues(0,lib.dt())
		end
	end
end

function Hrp_OnEvent (self, event, unit)
	if event=="UNIT_RUNIC_POWER" then
		if unit=="player" then
			self.freq=0
			Hrp_Update(self)
		end
	else
		self:SetMinMaxValues(0,lib.rp())
	end
end

function Hrp_Update (self)
	local now = GetTime()
	if (now >= self.lu + self.freq) then
		self.lu=now
		self.freq=cfg.freq
		local bar=self:GetValue()
		local power=UnitPower("player")
		if not (bar==power) then
			self:SetValue(power)
			self.text:SetText(power>0 and power or "")
		end
	end
end

function HruneFrame_OnEvent (self, event, ...)
	if ( event == "PLAYER_ENTERING_WORLD" or  event == "PLAYER_UNGHOST") then
		for i = 1, 6 do
			self[i].freq=0
			Hrune_Update(self[i])
		end
	elseif ( event == "RUNE_POWER_UPDATE" ) then
		local rune, usable = ...;
--		print(...)
--[[		if (not usable and rune and self[rune] ) then
			self[rune].freq=0
			Hrune_Update(self[rune])
		elseif ( usable and rune and self[rune] ) then
			self[rune].freq=0
			Hrune_Update(self[rune])
--			self[rune].shine:SetVertexColor(1, 1, 1);
--			HruneButton_ShineFadeIn(self[rune].shine)
			self[rune].shine.fadeInfo.finishedFunc = function()
				UIFrameFadeOut(self[rune].shine,0.3,1,0)
			end
			UIFrameFadeIn(self[rune].shine,0.3,0,1)
			print("Fade")
		end]]
		if(rune and self[rune]) then
			self[rune].freq=0
			Hrune_Update(self[rune])
		end
	elseif ( event == "RUNE_TYPE_UPDATE" ) then
		local rune = ...;
		if ( rune ) then
			self[rune].freq=0
			Hrune_Update(self[rune])
		end
	end
end

HruneFrame_OnLoad()