-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg
  
-- holder for some lib functions
local lib = CreateFrame("Frame")

local backdrop_tab = { 
    bgFile = cfg.backdrop_texture, 
    edgeFile = cfg.backdrop_edge_texture,
    tile = false,
    tileSize = 0, 
    edgeSize = 5, 
    insets = { 
      left = 5, 
      right = 5, 
      top = 5, 
      bottom = 5,
    },
  }
  
-- backdrop func
  lib.gen_backdrop = function(f)
  	local h = CreateFrame("Frame", nil, f)
    h:SetFrameLevel(0)
    h:SetPoint("TOPLEFT",-5,5)
    h:SetPoint("BOTTOMRIGHT",5,-5)
    h:SetBackdrop(backdrop_tab)
    h:SetBackdropColor(0,0,0,0)
   	h:SetBackdropBorderColor(1,0,0,1)
  end

lib.isDK = function()
	if select(2,UnitClass("player")) == "DEATHKNIGHT" then return(true) else return(nil) end
end

lib.rp = function()
	if (cfg.release==3) then
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(2,2);
		return(100+15*currRank)
	else
		return(100)
	end
end

lib.dt = function()
	if (cfg.release==3) then
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(3,4)
		return(15+3*currRank)
	else
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(3,3)
		return(30+6*currRank)
	end
end


lib.tal = function()
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
	    print(GetTalentTabInfo(t)..":")
    	local numTalents = GetNumTalents(t)
	    for i=1, numTalents do
	        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i)
	        print(t.." "..i.." - "..nameTalent..": "..currRank.."/"..maxRank)
	    end
	end
end

lib.hideRuneFrame=function()
	RuneFrame:Hide()
	RuneFrame.Show = function() end
	RuneFrame.SetPoint = function() end
	RuneFrame.ClearAllPoints = function() end
	RuneFrame.SetAllPoints = function() end
	RuneFrame:UnregisterEvent("RUNE_POWER_UPDATE");
	RuneFrame:UnregisterEvent("RUNE_TYPE_UPDATE");
	RuneFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	RuneFrame:SetScript("OnEvent", nil);
	RuneFrame:SetParent(nil)
end

ns.lib = lib